--[[
%% properties
%% autostart
%% globals
--]]
 
-- DIESE DATEN ANPASSEN (netatmo API)
local client_id = '55a6a197a8'
local client_secret = '7xhp'
local username = 'MAIL'
local password = 'PASSWORD'
------------------------------------------------------
local refresh = 300
local debug = 1
------------------------------------------------------

-- AB HIER NICHTS MEHR ANPASSEN
local token = ''
local request_body = ''
local rains = {hour = -1000, day = -1000, week = -1000, month = -1000}
 
local sourceTrigger = fibaro:getSourceTrigger()
local max_counter = 6
 
Debug = function ( color, message )
  fibaro:debug(string.format('<%s style="color:%s;">%s', "span", color, message, "span"))
end
 
DebugError = function ( color, message )
  fibaro:debug(string.format('<%s style="color:%s;">%s', "span", color, message, "span"))
end

Debug( 'orange', 'netatmo v.31 (-IntuITech-) gestartet...' )
Debug( 'white', 'Refresh alle ' ..(refresh/60).. ' min.' )

function globalVar(var,val)
  local http = net.HTTPClient()
  http:request("http://127.0.0.1:11111/api/globalVariables", {
    options = {
    checkCertificate = false,
    method = 'POST',
    headers = {},
    data = '{"name":"'..var..'","value":"'..val..'"}',
    timeout = 10000
  },
  success = function(response)
            local result = response.data;
            if response.status == 200 or response.status == 201 then
              fibaro:debug('Status: ' ..response.status.. ' - Variable ' ..var.. ' wurde angelegt')
            else
              fibaro:debug('Error: ' ..response.status.. ' - Zugriff verweigert')
            end
            end,
  error = function(err)
          fibaro:debug('[ERROR] ' .. err)
          end
  })
end

function oAuth(nextFunction)
 local request_body = 'grant_type=password&client_id=' .. client_id .. '&client_secret=' .. client_secret .. '&username=' .. username .. '&password=' .. password .. '&scope=read_station'
 getResponseData('https://api.netatmo.net/oauth2/token', request_body, 
     function(data)
      if (data.access_token ~= nil) then
        token = data.access_token
        --fibaro:debug(token)
        if (debug == 1) then
        Debug( 'green', 'oAuth 2.0 check - API erfolgreich verbunden.' )
        end
        getDevices()
      else
        DebugError( 'red', 'oAuth 2.0 konnte nicht durchgeführt werden! Bitte die Anmeldedaten überprüfen')
      end
    end
    )
    setTimeout(oAuth, refresh*1000);
end
 
function getResponseData(url, body, func)
 local http = net.HTTPClient()
 http:request(url, { 
 options = { 
 checkCertificate = false,       
 method = 'POST', 
         headers = {
 ['Content-Type'] = 'application/x-www-form-urlencoded;charset=UTF-8'
 },
 data = body
 },
 success = function(response) 
 func(json.decode(response.data))
 end
 })   
end
 
function getDevices()
 getResponseData('https://api.netatmo.net/api/getstationsdata','access_token='..token, 
 function(data)
 if (data.body ~= nil) then   
  if (debug == 1) then
    Debug( 'green', 'netatmo Windmesser wird gesucht...' );
  end
       --fibaro:debug(data.body.modules.data_type[1])
  for _, v in pairs(data.body.devices) do
         int_id = v._id
  		   Debug( 'green', 'Mainstation: ' ..int_id)
         local counter = 1
          while (counter < max_counter) do
           if (v.modules[counter].data_type[1] == 'Wind') then
              wind_id = v.modules[counter]._id
              if (debug == 1) then
                Debug( 'green', 'Windmesser: ' ..wind_id);
              end
              if wind_id ~= nil then
                getmeasureWind()
              end
           else
             --Debug( 'red', 'Kein Windmesser gefunden.' );
           end
           counter = counter + 1
           fibaro:sleep(3*1000)
         end
        end
  else
      DebugError( 'red', 'device-list konnte nicht abgefragt werden! Bitte nächsten Durchlauf abwarten')
  end
 end
    )
end
 
function getmeasureWind()
   request_body_wind = 'access_token='..token..'&device_id='..int_id..'&module_id='..wind_id..'&scale=max&type=WindStrength,WindAngle,GustStrength,GustAngle&date_end=last'
   getResponseData('https://api.netatmo.net/api/getmeasure', request_body_wind, 
 function(getData)
   if (getData.body ~= nil) then
       WindStrength = getData.body[1].value[1][1]
       WindAngle = getData.body[1].value[1][2]
       GustStrength = getData.body[1].value[1][3]
       GustAngle= getData.body[1].value[1][4]
       if (debug == 1) then
        Debug( 'white', 'Windgeschwindigkeit: ' .. WindStrength .. ' km/h' );
       end
        if fibaro:getGlobalValue('windstaerke') ~= nil then
        fibaro:setGlobal('windstaerke', WindStrength)
       else
        DebugError( 'red', 'Varible windstaerke nicht gefunden. Wird erstellt.')
        globalVar('windstaerke', WindStrength)
       end
       if fibaro:getGlobalValue('windrichtung') ~= nil then
        fibaro:setGlobal('windrichtung', WindAngle)
       else
        DebugError( 'red', 'Varible windrichtung nicht gefunden. Wird erstellt.')
        globalVar('windrichtung', WindAngle)
       end
       if fibaro:getGlobalValue('boenstaerke') ~= nil then
        fibaro:setGlobal('boenstaerke', GustStrength)
       else
        DebugError( 'red', 'Varible boenstaerke nicht gefunden. Wird erstellt.')
        globalVar('boenstaerke', GustStrength)
       end
       if fibaro:getGlobalValue('boenrichtung') ~= nil then
        fibaro:setGlobal('boenrichtung', GustAngle)
       else
        DebugError( 'red', 'Varible boenrichtung nicht gefunden. Wird erstellt.')
        globalVar('boenrichtung', GustAngle)
       end 
   else
     DebugError( 'red', 'API-Call konnte nicht durchgeführt werden! API nicht erreichbar! Bitte nächsten Durchlauf abwarten.')
   end
 end
 )
end
  
if (sourceTrigger['type'] == 'autostart') then
 oAuth();
end